//------------------------------------
//
//	TRACKER.JS
//	Requires:	jquery 1.6.x
//
//------------------------------------

////////////////////////////
// BEGIN JQUERY

var allowTrackerCloseReload = false;

$(function () {

  // Objects
  var $t = $('#atr_tracker'); 	// The tracker popup
  var $lin = $('#logged_in'); 	// The logged in body
  var $lout = $('#logged_out'); // The logged out body
  var $ns = $('#notifications'); // The notifications select
  var $w = $(window); 			// The window
  var $a = $t.find('.arrow'); 	// The arrow
  var $this; 					// The icon, we set this each time one is clicked
  var $confirm = $t.find('#confirmbutton'); // confirm button

  //var $related_content_odds = $('#related_content_odds'); //tipping article horses - have to add to article
  //var $recommended = $('#recommended_bet'); //tipping article horses - within content
  //var $trackericon = $('<a class="tracker_popup" title="Chosen Horse" href="#">ATR Tracker</a>'); //tracker icon HTML

  // Variables
  var visible = false; 		// Global visible status
  var hover = false; 			// If this is true, a screen click will not close the tracker
  var sopen = false;
  var margin = 10; 			// The distance from the edge of the window which will trigger a position change to avoid going off screen (in px)
  var mouseBan = false; 		// Is the mouse banned?
  var m; 						// The animation offset distance

  var horsename; //name of horse
  var horseid; //id of horse
  var hash; //hashed value



  //find tipped horses and add HTML
  //$trackericon.appendTo($recommended.find('.horse'));

  //turn icons "on" if logged in
  if (isCookie('ATRUID')) {
    $('.tracker_popup, .tracker_button').addClass("logged_in")
  }

  // Click the icon
  $('.tracker_popup, .tracker_button').click(function (e) {

    // Is the moose banned?
    if (!mouseBan) {

      // Is the tracker visible?
      if (visible) {

        closeTracker();

      } else {

        // Ban further clicks for now
        mouseBan = true;

        // Tracker is visible
        visible = true;

        // Set $this for use in positioning
        $this = $(this);

        //set title if not already done so - tipping articles
        /*
        if ($this.attr('title') == "Chosen Horse") {
        $this.attr('title', $this.parent('span').text().replace(' ATR Tracker', ''));
        }
        */


        //hide stuff
        $('#logged_in, #logged_out').hide();
        $t.find('#trackermanage').hide();

        // Logged in or out?
        if ($this.hasClass('logged_in')) {
          $lin.show();
          OpenTrackerMessage("main");
          $ns.siblings('span').text("Choose frequency");
          document.TrackerForm.reset();
        } else {
          $lout.show();
        }

        //get horse data
        horsename = $this.attr('title');
        horseid = $this.attr('id').substr(4);
        hash = hex_md5(getCookie("ATRToken") + "|" + horseid);

        // Change horse name
        $t.find('.tracker_horse').text(horsename);

        //update horseid, token and hash
        document.TrackerForm.horseid.value = horseid;
        document.TrackerForm.horsename.value = horsename;
        document.TrackerForm.token.value = getCookie("ATRToken");
        document.TrackerForm.hash.value = hash;

        // Show the tracker, set position and animate it in
        $t.show().css(coords());

        // Work out the offset margin, for the animation
        m = $a.hasClass('up') ? 10 : -10;

        // Do some animating
        $t.css({
          'opacity': 0,
          'margin-top': m
        }).animate({
          'opacity': 1,
          'margin-top': 0
        }, 100, function () {

          if ($.browser.msie && parseFloat($.browser.version) <= 8) {

            // NOTHING

          } else {

            $ns.css({
              'width': $ns.parent('span').width(),
              'height': $ns.parent('span').height(),
              'padding': 0,
              'opacity': 0
            });

          }

          mouseBan = false;

        });

        // Set a global click that will close
        $('body').mouseup(function () {

          if (!hover) {
            closeTracker();
          }

        });

      }

    }

    // Stop badness
    e.preventDefault();

  });


  // Tracker hover
  $t.hover(function () {
    hover = true;
  }, function () {
    hover = false;
  });


  // Notifications change
  $ns.change(function () {

    var text = $ns.find('option:selected').text();

    $ns.siblings('span').text(text == 'Until I delete from my list' ? 'Until I delete' : text);

  }).focus(function () {

    sopen = true;

  }).blur(function () {

    sopen = false;

  });


  // Close button
  $t.find('.header a').click(function (e) {

    closeTracker();

    e.preventDefault();

  });


  // Close the tracker
  function closeTracker() {

    if (!sopen) {

      // Tracker is not visible
      visible = false;

      // Ban the mouse
      mooseBan = true;

      // Hide the tracker
      $t.animate({
        'opacity': 0,
        'margin-top': m
      }, 100, function () {

        $(this).hide();
        mooseBan = false;

      });

      if (allowTrackerCloseReload && document.location.pathname.indexOf("/tracker") > -1) {
        //window.location.reload();
        window.location.assign("/tracker/myatrtracker.aspx?ref=trackerpopup&horse=" + escape(horsename) + "&h=" + hash);
      }

      // Unbind some stuff
      $('body').unbind('mouseup');

    }

  }


  // Discover coordinates
  function coords(e) {

    // Get window metrics
    var scrT = $w.scrollTop(); 	// The x scroll position
    var scrL = $w.scrollLeft()		// The y scroll position
    var win = $w.width(); 		// The window width

    // Get tooltip metrics
    var w = $t.outerWidth(); 	// The width of the tracker
    var h = $t.outerHeight(); 	// The height of the tracker

    // The x & y position of the icon that has been clicked
    var xp = $this.offset().left + Math.round($this.outerWidth() / 2);
    var yp = $this.offset().top;

    // Work out x
    var x = xp < win + scrL - Math.round(w / 2) - margin ? xp - Math.round(w / 2) : win + scrL - (w + margin);

    // Top or bottom? We work out the space available, if it is less than the defined margin in any direction then we change the position.
    if ((yp + $this.outerHeight() + h + margin) > (scrT + $w.height())) {

      // Set arrow to down
      $a.removeClass('up').addClass('down');

      // Figure out y
      var y = yp - h - margin;

    } else {

      // Adjust the y point as we need to account for the target height
      yp += $this.outerHeight();

      // Set arrow to up
      $a.removeClass('down').addClass('up');

      // Figure out y
      var y = yp + margin;

    }

    // Final off the screen check
    if (x < scrL + margin) {
      x = scrL + margin;
    }

    //console.log('x: ' + x + ' y: ' + y);

    // Send back the x and y for the css
    return { top: y, left: x };

  }


  // TABLE SORTING!

  $('#tracker_current table, #tracker_archive table').each(function () {

    var $table = $(this),
			$tBody = $table.find('tbody'),
			$sorting = $table.find('.sorting'),
			$tr = $table.find('tbody tr');

    function sortRows(row, kind, reverse) {

      //console.log('Sort', row.length, 'rows by', kind, 'from', reverse ? 'bottom to top' : 'top to bottom');

      var total = row.length,
				kindArray = [];

      for (i = 0; i < total; i++) {

        kindArray[i] = {
          pos: i,
          val: $(row[i]).attr('data-sort-' + kind)
        }

      }

      kindArray.sort(function (a, b) {

        var textA = a.val.toUpperCase();
        var textB = b.val.toUpperCase();
        return (textA < textB) ? -1 : (textA > textB) ? 1 : 0;

      });

      if (reverse)
        kindArray.reverse();

      for (i = 0; i < total; i++) {

        $(row[kindArray[i].pos]).appendTo($tBody);

      }

    }

    $sorting.find('a').click(function (e) {

      var $a = $(this),
				sortBy = $a.attr('data-sort'),
				reverse = $a.is('.reverse');

      if ($a.is('.active')) {

        if (reverse) {

          $a.removeClass('reverse');

        } else {

          $a.addClass('reverse');

        }

        reverse = !reverse;

      } else {

        $sorting.find('.active').removeClass('active');
        $a.addClass('active');

      }

      sortRows($tr, sortBy, reverse);

      e.preventDefault();

    });

  });

});


function UpdateTrackerStatus() {

  var status = (("" + arguments[0]) == "undefined" || arguments[0] == "") ? "" : arguments[0];
  var $t = $('#atr_tracker');

  switch (status) {
    case 1:
      OpenTrackerMessage("success")
      break;
    case 2:
      OpenTrackerMessage("duplicate")
      break;
    case 3:
      OpenTrackerMessage("maximum")
      break;
    default:
      OpenTrackerMessage("fail")
      break;
  }

  //set var to change event on close button
  allowTrackerCloseReload = true;
  //show manage tracker - only want to do this when we get a status returned
  $t.find('#trackermanage').show();
}

function OpenTrackerMessage(m) {

  var $t = $('#atr_tracker');

  //hide them all
  $t.find('#trackermain').hide();
  $t.find('#trackerfail').hide();
  $t.find('#trackerduplicate').hide();
  $t.find('#trackersuccess').hide();
  $t.find('#trackermaximum').hide();
  //show the one we want
  $t.find('#tracker' + m).show();
}